package jp.co.y_net.amm.dao;
import java.util.List;

import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Example;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.stereotype.Component;


@Component("orgDao")
public class OrgDao extends AbstractDao {
    
    /* 参照形処理 ------------------------------------------------------------------------------------------------ */
    /** ユニークキーを使用した取得 */
    public Org getByOrgid(Integer orgid) {
        return getByOrgid(orgid, false);
    }
    
    public Org getByOrgid(Integer orgid, boolean withDeleted) {
        Org cnd = new Org();
        cnd.setOrgid(orgid);
        List<Org> orgs = get(cnd, withDeleted);
        if(orgs.size() == 1) {
            return orgs.get(0);
        }
        return null;
    }

    /** 全件取得(論理削除除外) */
    public List<Org> get() {
        Org cnd = new Org();
        cnd.setDeleted(AppDef.FLASE); // 論理削除考慮
        return get(cnd);
    }
    /** 条件付き取得(論理削除除外) */
    public List<Org> get(Org cnd) {
        return get(cnd, false);
    }
    public List<Org> get(Org cnd, boolean withDeleted) {
        if (withDeleted == false) {
            if(cnd != null) {
                cnd.setDeleted(AppDef.FLASE); // 論理削除考慮
            }
        }

        HibernateTemplate hibernateTemplate = getHibernateTemplate();
        DetachedCriteria dc = DetachedCriteria.forClass(Org.class);
        dc.add(Example.create(cnd));
        @SuppressWarnings("unchecked")
        List<Org> list = (List<Org>) hibernateTemplate.findByCriteria(dc);
        hibernateTemplate.clear();
        return list;
    }
    /* 更新系処理 ------------------------------------------------------------------------------------------------ */
    private static final String ENTITYNAME = "Org";
    private static final String PKEYNAME = "orgid";
    /**
     * 登録処理
     * ・必要なカラムを自動採番する
     * ・共通処理を実施する。
     * @param item
     */
    public void add(Org item, Integer updateusrid) {
        /* 自動採番 */
        item.setOrgid(getNextId(ENTITYNAME, PKEYNAME));
        /* Insert実施 */
        super.add(item, updateusrid);
    }
    public void update(Org item, Integer updateusrid) {
        super.update(item, updateusrid);
    }
    public void removeLogical(Org item, Integer updateusrid) {
        super.removeLogical(item, updateusrid);
    }


}
